// bookWindow.java

// import the Graphical User Interface (GUI) classes
/*
import java.awt.Frame;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.FlowLayout();
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;
import java.awt.Label;
*/
import java.awt.*;
import java.awt.event.*;

// our book class
import book;

// a utility class
import java.util.Vector;

/**
 * Class to implement a graphical window into a
 * bookshelf.
 * @version 1.2
 * @author Michael C. Daconta
 */
public class bookWindow extends Frame implements ActionListener
{
    /** book title. */
    TextField title;
    /** author of the book. */
    TextField author;
    /** publisher of the book. */
    TextField publisher;
    /** book store. */
    Vector theBooks;
    /** current index. */
    int iCurrentIdx;

    /** bookWindow constructor. */
    public bookWindow()
    {
        super("Book Shelf");

        setLayout(new BorderLayout());

        // initialize the growable array
        theBooks = new Vector(3);
        iCurrentIdx = 0;

        Panel centerPanel = new Panel();
        centerPanel.setLayout(new GridLayout(0, 2));

        centerPanel.add(new Label("Title"));
        centerPanel.add(title = new TextField(20));

        centerPanel.add(new Label("Author"));
        centerPanel.add(author = new TextField(20));

        centerPanel.add(new Label("Publisher"));
        centerPanel.add(publisher = new TextField(20));

        add("Center", centerPanel);

        Panel bottomPanel = new Panel();
        bottomPanel.setLayout(new FlowLayout());
        // create buttons
        Button b1 = new Button("store");
        b1.addActionListener(this);
        Button b2 = new Button("clear");
        b2.addActionListener(this);
        Button b3 = new Button("prev");
        b3.addActionListener(this);
        Button b4 = new Button("next");
        b4.addActionListener(this);
        Button b5 = new Button("exit");
        b5.addActionListener(this);
        bottomPanel.add(b1);
        bottomPanel.add(b2);
        bottomPanel.add(b3);
        bottomPanel.add(b4);
        bottomPanel.add(b5);
        add("South", bottomPanel);

        setLocation(200, 100);
        pack();
        setVisible(true);
    } // end of constructor

    /** necessary to implement ActionListener. */
    public void actionPerformed(ActionEvent evt)
    {
        String command = evt.getActionCommand();
        if ("store".equals(command))
        {
            book aBook = new book(title.getText(),
                                  author.getText(),
                                  publisher.getText());

            theBooks.addElement(aBook);
            iCurrentIdx = theBooks.size();
            title.setText("");
            author.setText("");
            publisher.setText("");
        }
        else if ("clear".equals(command))
        {
            title.setText("");
            author.setText("");
            publisher.setText("");
        }
        else if ("prev".equals(command))
        {
            if (iCurrentIdx > 0)
            {
                    book aBook = (book) theBooks.elementAt(--iCurrentIdx);
                    title.setText(aBook.getTitle());
                    author.setText(aBook.getAuthor());
                    publisher.setText(aBook.getPublisher());
            }
        }
        else if ("next".equals(command))
        {
            if (iCurrentIdx < (theBooks.size()-1))
            {
                    book aBook = (book) theBooks.elementAt(++iCurrentIdx);
                    title.setText(aBook.getTitle());
                    author.setText(aBook.getAuthor());
                    publisher.setText(aBook.getPublisher());
            }
        }
        else if ("exit".equals(command))
        {
            System.exit(0);
        }
    } // end of actionPerformed

    /** main method to invoke from JVM. */
    public static void main(String args[])
    {
        new bookWindow();
    }
}
