package jwiley.chp10;

import java.awt.Button;
import java.awt.peer.ComponentPeer;
import java.awt.Frame;
/**
 *  TestPeer.java
 *  A class to test the use of native peers to render the
 *  Java cross-platform GUI.
 *  @version 1.1
 *  @author M. Daconta.
 *
 * Note: getPeer() is deprecated. As of JDK version 1.1, 
 * programs should not directly manipulate peers. 
 */
class TestPeer
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        Button myButton = new Button("my Button");
        ComponentPeer buttonPeer = myButton.getPeer();

        if (buttonPeer == null)
        {
            System.out.println("Button peer not yet created.");
            System.out.println("Button is: " + myButton.toString());
        }
        else
        {
            System.out.println("Button Peer is Created!");
            System.out.println(buttonPeer.toString());
        }

        Frame myFrame = new Frame("my Frame");
        myFrame.add("Center", myButton);
        myFrame.pack();
        myFrame.setVisible(true);  // Here is where peer will be created.

        buttonPeer = myButton.getPeer();
        if (buttonPeer == null)
        {
            System.out.println("Button peer not yet created.");
            System.out.println("Button is: " + myButton.toString());
        }
        else
        {
            System.out.println("Button Peer is Created!");
            System.out.println(buttonPeer.toString());
        }

        ComponentPeer framePeer = myFrame.getPeer();
        System.out.println("Frame Peer is also created.");
        System.out.println(framePeer.toString());
    }
}
