package jwiley.chp17;
import java.security.*;
import java.util.Enumeration;

/**
 *  getNamedProvider returns the provider information for the provider given.
 *  @version 1.1
 *  @author A. Saganich
 *  @see java.Security.
 */
class getNamedProvider
{
	public static void main(String args[])
	{

		if ( args.length < 1)
		{
			System.out.println("Usage: getNamedProvider provider1 provider2 ...\n");
			System.exit(0);
		}
		// Note that provider properties are provider specific
		// The generate security properties are listed below.
		// security.provider.1
		// system.scope
		// identity.database
		//
		System.out.println("General system security propertys");
		System.out.println("Property security.provider.1 =" + Security.getProperty("security.provider.1"));
		System.out.println("         system.scope =" + Security.getProperty("system.scope"));
		System.out.println("         identity.database =" + Security.getProperty("identity.database"));
		System.out.println("\n");

		for (int i = 0; i < args.length; i++)
		{	
			String providerName = args[i];
			System.out.println("Getting information about " + providerName);

			Provider provider = Security.getProvider(providerName);
			System.out.println( "Provider name  " + provider.getName());
			System.out.println( "Provider version  " + provider.getVersion());
			System.out.println( "Provider info  " + provider.getInfo());
			System.out.println("\n");
			//
			// Print all the security properties.
			//
			System.out.println( "Provider properties");
			for (Enumeration e = provider.propertyNames() ; e.hasMoreElements() ;) 
			{
				String propertyName = (String)e.nextElement();
				System.out.println("\t " + propertyName);
			}
		}
	}
}
