package jwiley.chp19;
import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Enumeration;

/**
 * public class TestResources
 * @author A. Saganich
 * @version 1.1
 *
 *  Sample applet to exercise the use of Locales and ResourceBundles.
 *
 *  @see java.util.Locale;
 */


public class TestResources extends Applet 
{
	
	Locale current;
	private Locale supported[] =
	{
		Locale.US,
		Locale.UK,
		Locale.FRENCH,
		Locale.GERMAN
	};
	
	/** Determine what the current locale is */
	public void init() 
	{
		current = getLocale();
	}

	/** 
	* Display the currently supported locales and the associated resources
	* And test if the current locale is supported.
	*/
	public void paint(Graphics g) 
	{
		int y = 10;
		for ( int i = 0; i < supported.length; i++)
		{
			y = dump(supported[i],y,g);
		}
		
	}
	int dump(Locale locale, int y,Graphics g) 
	{
		g.drawString("Locale:" + locale.getDisplayName() , 10, y+=10);
		g.drawString("Known resources are ", 10, y+=10);
		ResourceBundle myResources = ResourceBundle.getBundle("MyResources",locale);
		for (Enumeration e = myResources.getKeys();e.hasMoreElements() ;) 
		{ 	
			String key = (String)e.nextElement();
			String value = (String)myResources.getObject(key);
			g.drawString("Key:"+key+"="+value, 20, y+=10);
		}
		return y;
	}

	/**
	 * Simple main method to test the applet.
	 */
	static public void main(String args[])
	{
	    class ShutdownAdapter extends WindowAdapter
	    {
	        public void windowClosing(WindowEvent e)
	        { System.exit(0); }
	    }

		Frame	myFrame	= new Frame("TestResources");
		myFrame.addWindowListener(new ShutdownAdapter());
		TestResources TestResources = new TestResources();
		myFrame.setSize(250,350);
		myFrame.add("Center",TestResources);
		TestResources.init();
		TestResources.start();
		myFrame.show();
		
		
	}
}