// ArrayTest.java
package jwiley.chp2;

/**
 * Simple class (similar to structure) to use in
 * arrayTest example.
 * @version 1.1
 * @author Michael C. Daconta
 */
class testObject
{
    /** integer data member. */
    int anInt=0;
    /** string data member. */
    String aString="";

    /** constructor to create and initialize an object. */
    testObject(int theInt, String theString)
    {
        anInt = theInt;
        aString = new String(theString);
    }

    /** method to print a testObject. */
    void printObject()
    {
        System.out.println("anInt   : " + anInt);
        System.out.println("aString : " + aString);
    }
}

/**
 * Simple class to demonstrate array operations.
 * @version 1.1
 * @author Michael C. Daconta
 */
class ArrayTest
{
    /** Main method to invoke from JVM. */
    public static void main(String args[])
    {
        int a[] = { 1, 2, 3 };
        int b[];
        int c[];

        b = a;
        c = new int[3];
        c = a;

        for (int i=0; i < b.length; i++)
        {
            System.out.println("a[" + i +"] is " + a[i]);
            System.out.println("b[" + i +"] is " + b[i]);
            System.out.println("c[" + i +"] is " + c[i]);
        }

        testObject objArray[];
        testObject anObject;
        testObject realObject = new testObject(1,"Mike");

        objArray = new testObject[3];
        for (int i=0; i < objArray.length; i++)
            objArray[i] = new testObject(i,"person"+i);

        anObject = realObject;

        for (int i=0; i < objArray.length; i++)
            objArray[i].printObject();

        realObject.printObject();
        anObject.printObject();
    }
}
