// CheckBook.java
package jwiley.chp2;

/* this program will demonstrate both Strings and Arrays */
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.lang.Integer;
import java.io.IOException;

/**
 * Class to represent a single check.
 * @author Michael C. Daconta
 * @version 1.1
 */
class Check
{
    /** check number. */
    public int number;
    /** payable to. */
    public String to;
    /** amount of check. */
    public Float amount;
    /** memo field of check. */
    public String memo;

    /** Method to get check data. */
    void enterCheck()
    {
       try
       {
            System.out.print("Check number: ");
            System.out.flush();
            String numStr = CheckBook.br.readLine();
            number = Integer.parseInt(numStr);
            System.out.print("Check to: ");
            System.out.flush();
            to = CheckBook.br.readLine();
            System.out.print("Check amount: ");
            System.out.flush();
            String amtStr = CheckBook.br.readLine();
            amount = Float.valueOf(amtStr);
            System.out.print("Check memo: ");
            System.out.flush();
            memo = CheckBook.br.readLine();
       } catch (IOException ioe)
         {
            System.out.println(ioe.toString());
            System.out.println("Unable to get Check data.");
            return;
         }
    }
}

/**
 * Class to represent a check book.
 * @author Michael C. Daconta
 * @version 1.1
 */
class CheckBook
{
    /** buffered reader of standard input stream. */
    static BufferedReader br =
            new BufferedReader(new InputStreamReader(System.in));

    /** Main() method to invoke from JVM. */
    public static void main(String args[])
    {
        Check theCheckBook[];

        /* enter the checks */
        System.out.print("Enter number of checks used this month: ");
        System.out.flush();
        String numStr = null;
        try {
                numStr = br.readLine();
        } catch (IOException ioe)
          {
                System.out.println(ioe.toString());
                System.exit(1);
          }
        int numChecks = Integer.parseInt(numStr);

        theCheckBook = new Check[numChecks];

        for (int i=0; i < numChecks; i++)
        {
            theCheckBook[i] = new Check();
            theCheckBook[i].enterCheck();
        }

        /* print out check register.
           First print the header. */
        System.out.println("Check #\t       Payee        \t Amount \tMemo");
        System.out.println("--------------------------------------------------------");
        for (int i=0; i < numChecks; i++)
            System.out.println(theCheckBook[i].number + "\t" +
              pad(theCheckBook[i].to,20,' ') + "\t" +
              theCheckBook[i].amount + "\t" +
              theCheckBook[i].memo);

        /* calculate total expenses */
        double total=0.0;
        for (int i=0; i < numChecks; i++)
        {
            total += theCheckBook[i].amount.doubleValue();
        }
        System.out.println("Total expenses for month: $" + total);
    }

    /** method to pad strings. */
    static String pad(String inString, int desiredLength, char padChar)
    {
        if (inString.length() >= desiredLength)
            return new String(inString);

        StringBuffer newStr = new StringBuffer(inString);
        for (int i=inString.length(); i < desiredLength; i++)
            newStr.append(padChar);

        return newStr.toString();
    }
}
