// Coord.java
package jwiley.chp2;

/**
 * A simple, 3 dimensional coordinate class.
 */
class Coord
{
    /** components. */
    int x,y,z;

    /** constructor. */
    Coord(int inX, int inY, int inZ)
    {
        x = inX; y = inY; z = inZ;
    }

    /** accessor. */
    int getX()
    { return x; }

    /** accessor. */
    int getY()
    { return y; }

    /** accessor. */
    int getZ()
    { return z; }

    /** mutator. */
    void setX(int inX)
    { x = inX; }

    /** mutator. */
    void setY(int inY)
    { y = inY; }

    /** mutator. */
    void setZ(int inZ)
    { z = inZ; }

    /** print out a String representation. */
    public String toString()
    {
        return "x: " + x + " y: " + y +
               " z: " + z;
    }

    /** method to scale this point. */
    void scalePt(int Scale)
    {
        x *= Scale;
        y *= Scale;
        z *= Scale;
    }

    /** static utility function */
    static Coord scalePt(Coord inCoord, int Scale)
    {
        int aX, aY, aZ;
        /* use methods */
        aX = inCoord.getX();
        aY = inCoord.getY();
        aZ = inCoord.getZ();
        aX *= Scale;
        aY *= Scale;
        aZ *= Scale;
        Coord outCoord = new Coord(aX, aY, aZ);
        return outCoord;
    }

    /** main method to invoke from JVM. */
    public static void main(String args[])
    {
        Coord aCoord = new Coord(4,5,2);

        /* use method */
        String coordStr = aCoord.toString();
        System.out.println("aCoord holds " + coordStr);

        /* use utility function */
        Coord scaleCoord = Coord.scalePt(aCoord,10);
        coordStr = scaleCoord.toString();
        System.out.println("scaleCoord holds " + coordStr);
    }
}
