// Rotate.java
package jwiley.chp2;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

/**
 * Class to demonstrate multi-dimensional arrays via
 * matrix rotation.
 */
class Rotate
{
    /** Main method to invoke from the JVM. */
    public static void main(String args[])
    {
        /* enter number of coordinates to rotate. */
        BufferedReader br =
                new BufferedReader(new InputStreamReader(System.in));
        System.out.print("Enter number of Coordinates: ");
        System.out.flush();
        String numStr = null;
        try
        {
            numStr = br.readLine();
        } catch (IOException ioe)
          {
            System.out.println(ioe.toString());
            System.exit(1);
          }
        int numCoords = Integer.parseInt(numStr);

        /* create a matrix of 2-d coordinates. */
        int coords[][] = new int[numCoords][2];

        /* Fill the matrix */
        for (int i=0; i < numCoords; i++)
        {
            boolean badInput=false;
            do
            {
                try
                {
                    System.out.println("Coordinate #" + i);
                    System.out.print("Enter x: ");
                    System.out.flush();
                    String xStr = br.readLine();
                    coords[i][0] = Integer.parseInt(xStr);

                    System.out.print("Enter y: ");
                    System.out.flush();
                    String yStr = br.readLine();
                    coords[i][1] = Integer.parseInt(yStr);
                    badInput=false;
                } catch (IOException ioe)
                  {
                    System.out.println(ioe.toString());
                    System.exit(1);
                  }
                  catch (NumberFormatException nfe)
                  {
                    System.out.println("Must enter a number.");
                    badInput=true;
                  }
            } while (badInput);
        }

        /* get the degree of Rotation */
        boolean badDegree=false;
        int degrees = 0;
        do
        {
            System.out.print("Enter degree of rotation (1-360): ");
            System.out.flush();
            String degStr = null;
            try
            {
                degStr = br.readLine();
                degrees = Integer.parseInt(degStr);
                badDegree=false;
            } catch (IOException ioe)
              {
                System.out.println(ioe.toString());
                System.exit(1);
              }
              catch (NumberFormatException nfe)
              {
                System.out.println("Enter number between 1 and 360.");
                badDegree=true;
              }
        } while (badDegree);

        /* translate degrees to radians */
        double radians = ((double)degrees/180.0) * Math.PI;
        System.out.println(degrees + " degrees is " + radians +
                           " radians.");

        /* create rotation Matrix */
        double rotMatrix[][] = new double[numCoords][2];

        /* perform the rotation */
        for (int i=0; i < numCoords; i++)
        {
            /* new X */
            rotMatrix[i][0] = Math.cos(radians) -
                              coords[i][1] * Math.sin(radians);

            /* new Y */
            rotMatrix[i][1] = Math.cos(radians) +
                              coords[i][0] * Math.sin(radians);
        }

        /* print the Rotation matrix */
        for (int i=0; i < numCoords; i++)
        {
            System.out.println("Rotated Coordinate #" + i);
            System.out.println("x :" + rotMatrix[i][0]);
            System.out.println("y :" + rotMatrix[i][1]);
        }
    }
}
