// HtmlAnchor
package jwiley.chp20.html;

/**
 * This class represents an html anchor, this class can be
 * used to provide anchors and hypertext links
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class HtmlAnchor implements HtmlComponent
{
    private HtmlComponent anchorSubject = new HtmlText("");
    private String        sName = "";
    private String        sLink = "";

    public HtmlAnchor ()    {   }

    public HtmlAnchor (String sName, HtmlComponent subject, String sLink)
    {
        this.sName = sName;
        this.anchorSubject = subject;
        this.sLink = sLink;
    }

    public void setName (String sName)
    {
        this.sName = sName;
    }

    public void setAnchorSubject (HtmlComponent subject)
    {
        this.anchorSubject = subject;
    }

    public void setAnchorSubject (String sSubject)
    {
        this.anchorSubject = new HtmlText(sSubject);
    }

    public void setLink (String sLink)
    {
        this.sLink = sLink;
    }

    public String getHtml()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("<A");
        if (!sName.equals(""))
            sbHtmlText.append(" NAME='" + sName + "'");

        if (!sLink.equals(""))
            sbHtmlText.append(" HREF=" + sLink);

        sbHtmlText.append(">");
        sbHtmlText.append(anchorSubject.getHtml());
        sbHtmlText.append("</A>");

        return (sbHtmlText.toString());
    }

}
