// HtmlTableRow.java
package jwiley.chp20.html;

import java.util.Vector;

/**
 * This class represents an html row
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class HtmlTableRow implements HtmlComponent
{
    private Vector vCells = new Vector();
    private Vector vParameters = new Vector();

    public HtmlTableRow ()      {   }

    public void addCell (HtmlTableCell cell)
    {
        vCells.addElement(cell);
    }

    public void addParameter(String sParameter)
    {
        vParameters.addElement(sParameter);
    }

    public String getHtml ()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("<TR");

        for (int iCount = 0; iCount < vParameters.size(); iCount++)
        {
            sbHtmlText.append(" " + (String)vParameters.elementAt(iCount));
        }
        sbHtmlText.append(">\n");

        for (int iCount = 0; iCount < vCells.size(); iCount++)
        {
            HtmlComponent comp = (HtmlComponent) vCells.elementAt(iCount);
            sbHtmlText.append(comp.getHtml());
        }

        sbHtmlText.append("</TR>\n");

        return (sbHtmlText.toString());

    }
}
