// LineSegment.java
package jwiley.chp3;
import java.awt.Point;

/**
 * Class to represent a line segment.
 */
class LineSegment
{
    /** points in line segment. */
    protected Point pts[];

    /** constructor */
    LineSegment(int x1, int y1, int x2, int y2)
    {
        pts = new Point[2];
        pts[0] = new Point(x1,y1);
        pts[1] = new Point(x2,y2);
    }

    /** accessor method. */
    Point getPoint(boolean first)
    {
        return (first ? pts[0] : pts[1]);
    }

    /** mutator method. */
    void setPoint(boolean first, int inX, int inY)
    {
        if (first)
        {
                pts[0].x = inX;
                pts[0].y = inY;
        }
        else
        {
                pts[1].x = inX;
                pts[1].y = inY;
        }
    }

    /** calculate slope. */
    double calculateSlope()
    {
        return ( (pts[0].y - pts[1].y) /
                 (pts[0].x - pts[1].x) );
    }

    /** calculate the length of the line segment. */
    double length()
    {
        int a = Math.abs(pts[0].x - pts[1].x);
        int b = Math.abs(pts[0].y - pts[1].y);
        double c = Math.sqrt( (a*a) + (b*b) );
        return c;
    }

    /** main method to invoke from JVM. */
    public static void main(String args[])
    {
        LineSegment aSegment = new LineSegment(0,0,4,4);
        Point one = aSegment.getPoint(true);
        Point two = aSegment.getPoint(false);
        double segSlope = aSegment.calculateSlope();
        double segLength = aSegment.length();
        System.out.println("Slope of segment is  :" + segSlope);
        System.out.println("Length of segment is :" + segLength);
    }
}
