// TstVirtual.java
package jwiley.chp3;

import java.util.Random;

/**
 * Class to represent a generic car.
 */
class car
{
    /** top speed of car. */
    int top_speed;
    /** number of gallons of gas. */
    int fuel_in_gallons;

    /** constructor. */
    car(int inSpeed, int inGallons)
    {
        top_speed = inSpeed;
        fuel_in_gallons = inGallons;
    }

    /** method to print how much fuel left in tank. */
    void howMuchFuel()
    {
        System.out.println("There is " + fuel_in_gallons +
                                " left.");
    }
}

/**
 * Specific type of car.
 */
class Honda extends car
{
    /** Model of car. */
    String model;
    /** constructor. */
    Honda(String theModel, int inSpeed, int inFuel)
    {
        super(inSpeed, inFuel);
        model = new String(theModel);
    }

    /** method to print out how much fuel left in tank. */
    void howMuchFuel()
    {
        System.out.println("My Honda " + model +
                           " has " + fuel_in_gallons +
                           " left.");
    }
}

/**
 * Specific type of car.
 */
class Dodge extends car
{
    /** Model of car. */
    String model;
    /** constructor. */
    Dodge(String theModel, int inSpeed, int inFuel)
    {
        super(inSpeed, inFuel);
        model = new String(theModel);
    }

    /** method to print out how much fuel left in tank. */
    void howMuchFuel()
    {
        System.out.println("My Dodge " + model +
                           " has " + fuel_in_gallons +
                           " left.");
    }
}

/**
 * Wrapper class to demonstrate virtual methods.
 */
class TstVirtual
{
    /** Random number class. */
    static Random dice = new Random();

    /** method to get a random type of car. */
    static car get_a_car()
    {
        if (dice.nextInt() % 2 == 0)
                return new Dodge("Caravan",90,20);
        else
                return new Honda("Civic",70,10);
    }

    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        car theCar;
        for (int i=0; i < 5; i++)
        {
            theCar = get_a_car();
            theCar.howMuchFuel();
        }
    }
}
