/** Traverse.java. */

package List;

/**
 * Traverse is an interface that is an abstraction for
 *   free-flow viewing of a connected list of objects.
 *   By free-flow viewing, I mean six operations:
 *   atStart(), atEnd(), next(), prev(), start() , end()
 */
public interface Traverse
{

	/** check if at the start of list. */
	public boolean atStart();

	/** check if at the end of list. */
	public boolean atEnd();

	/** access the next list element. */
	public Object next();

	/** access the previous list element. */
	public Object prev() throws IllegalListOpException;

	/** jump to the head of the list and return it. */
	public Object start();

	/** jump to the end of the list and return it. */
	public Object end();
}
