// TestSynch.java
import java.lang.Thread;
import java.lang.Exception;
import java.lang.Integer;
import java.util.Stack;
import java.util.Random;

/** Class Produces puts items in shared data store. */
class Producer extends Thread
{
	int Rest, qty, myNumber;
	Stack theStorage;
	static int ProducerCount = 0;

    /** constructor. */
	Producer(int millisRest, int numberToProduce, Stack aStack)
	{
		Rest = millisRest;
		qty = numberToProduce;
		ProducerCount++;
		myNumber = ProducerCount;
		theStorage = aStack;
	}

    /** implements runnable. */
	public void run()
	{
		int i=qty;

		while (i > 0)
		{
			System.out.println("Producer: " + myNumber +
							   " created and stored a product.");
			Integer anInt = new Integer(myNumber);
			theStorage.push(anInt);
			try { sleep(Rest); } catch (Exception e) { }
			i--;
		}
	}
}

/** a Consumer class pulls from shared data store. */
class Consumer extends Thread
{
	static int ConsumerCount = 0;
	int myNumber, delay, count;
	Stack theStorage;

    /** constructor. */
	Consumer(int millisToConsume, int numberToConsume, Stack aStack)
	{
		delay = millisToConsume;
		count = numberToConsume;
		theStorage = aStack;
		ConsumerCount++;
		myNumber = ConsumerCount;
	}

    /** implements runnable. */
	public void run()
	{
		int i=count;
		while (i > 0)
		{
			System.out.println("Store holds " + theStorage.size() +
									" products.");
			if (theStorage.size() > 0)
		    {
				Object o = theStorage.pop();
				System.out.println("Consumer: " + myNumber +
										" consumed a product.");
				try { sleep(delay); } catch (Exception e) { }
			}
			else
			{
				System.out.println("Consumer: " + myNumber +
								   " could NOT get any product!");
				break;
			}
			i--;
		}
	}
}

/** Class to test synchronization.  The Stack data object uses
    synchronized push() and pop() methods. */
public class TestSynch
{
    /** main() method to invoke from JVM. */
	public static void main(String args[])
	{
		if (args.length < 2)
		{
			System.out.println("Usage: java tstSynch #producers #consumers");
			System.exit(1);
		}

		int producers = Integer.parseInt(args[0]);
		int consumers = Integer.parseInt(args[1]);

		// create the stack
		Stack theStore = new Stack();

		Random dice = new Random();

		for (int i=0; i < producers; i++)
		{
			int produceCount = Math.abs(dice.nextInt() % 5);
			int millis = Math.abs(dice.nextInt() % 500);
			System.out.println("ProduceCount " + produceCount);
			Producer p = new Producer(millis, produceCount, theStore);
			p.start();
		}

		try { Thread.sleep(200); } catch (Exception e) { }

		for (int i=0; i < consumers; i++)
		{
			int hunger = Math.abs(dice.nextInt() % 5);
			int timeToEat = Math.abs(dice.nextInt() % 500);
			System.out.println("hunger: " + hunger);
			Consumer c = new Consumer(timeToEat, hunger, theStore);
			c.start();
		}

		try { Thread.sleep(2000); } catch (Exception e) { }

		System.out.println("Active threads: " + Thread.activeCount());
	}
}
