// ClassHierarchy.java

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

/** Class to demonstrate the Class class. */
public class ClassHierarchy
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
       try
       {
            BufferedReader br = new BufferedReader(
                                new InputStreamReader(System.in));
            System.out.print("Enter class to print hierarchy: ");
            System.out.flush();
            String ClassName = br.readLine();
            Class aClass = Class.forName(ClassName);
            System.out.println("Class name: " + aClass.getName());
            Class superClass;
            do 
 {
                    superClass = aClass.getSuperclass();
                    if (superClass != null)
                    {
                            aClass = Class.forName(superClass.getName());
                            System.out.println("Class name: " +
                                                    superClass.getName());
                    }
                    else
                    {
                            System.out.println("No superclass.");
                            break;
                    }
            } while (!superClass.getName().equals("java.lang.Object"));
       } catch (ClassNotFoundException cfe)
         {
            System.out.println("Class Not Found: " + cfe.getMessage());
         }
         catch (IOException ioe)
         {
            System.out.println("IO Exception.");
            System.out.println(ioe.getMessage());
         }
    }
}
