
package jwiley.chp7;

import java.awt.Point;
import java.awt.Rectangle;
// AerialView.java
import java.awt.Canvas;
import java.util.Observable;
import java.util.Observer;

/**
 * This class displays an aerial view of the given model
 *
 * @author  Eric Monk
 * @version 1.0
 */

public class AerialView implements Observer
{
    SimplePositioner    sp;

    public AerialView (PositionModel pm)
    {
        sp = new SimplePositioner(calculatePercent(pm), new Rectangle(6,6));
    }

    public Canvas getCanvas()
    {
        return (sp);
    }

    public void update(Observable o, Object arg)
    {
        PositionModel pm = (PositionModel) arg;
        Point p = calculatePercent(pm);
        sp.setMarker(p.x, p.y);
    }

    Point calculatePercent(PositionModel pm)
    {
        Rectangle r = pm.getFieldSize();
        Point p = pm.getPosition();

        int iXPercent = (int) (((float)p.x / (float)r.width) * 100);
        int iYPercent = (int) (((float)p.y / (float)r.height) * 100);

        return (new Point(iXPercent, iYPercent));
    }

}
