// ModelUpdater.java
package jwiley.chp7;

/**
 * This class is used to update the model based on user input
 *
 * @author  Eric Monk
 * @version 1.0
 */

public class ModelUpdater implements Runnable
{
    ControllerFrame controllerFrame;
    Object          target;
    boolean         bRun = false;
    int             iIncrement = 4;

    public ModelUpdater (ControllerFrame controllerFrame)
    {
        this.controllerFrame = controllerFrame;
    }

    public void setTarget (Object target)
    {
        this.target = target;
    }

    public void setRun (boolean bRun)
    {
        this.bRun = bRun;
    }

    public void run ()
    {
        while (true)
        {
            if (bRun)
            {
                if (target == controllerFrame.cmdWest)
                {
                    controllerFrame.pm.moveLeft(iIncrement);
                }

                else if (target == controllerFrame.cmdNW)
                {
                    controllerFrame.pm.moveLeft(iIncrement);
                    controllerFrame.pm.moveUp(iIncrement);
                }

                else if (target == controllerFrame.cmdNorth)
                {
                    controllerFrame.pm.moveUp(iIncrement);
                }

                else if (target == controllerFrame.cmdNE)
                {
                    controllerFrame.pm.moveRight(iIncrement);
                    controllerFrame.pm.moveUp(iIncrement);
                }

                else if (target == controllerFrame.cmdEast)
                {
                    controllerFrame.pm.moveRight(iIncrement);
                }

                else if (target == controllerFrame.cmdSE)
                {
                    controllerFrame.pm.moveRight(iIncrement);
                    controllerFrame.pm.moveDown(iIncrement);
                }

                else if (target == controllerFrame.cmdSouth)
                {
                    controllerFrame.pm.moveDown(iIncrement);
                }

                else if (target == controllerFrame.cmdSW)
                {
                    controllerFrame.pm.moveLeft(iIncrement);
                    controllerFrame.pm.moveDown(iIncrement);
                }

                try {
                    Thread.sleep(50);
                } catch (InterruptedException ie)   {   }
            }
            else
                Thread.yield();
        }
    }
}