
package jwiley.chp7;

// PositionModel.java
import java.util.Observable;
import java.awt.Point;
import java.awt.Rectangle;

/**
 * This class is a simple model of a point inside a rectangle
 *
 * @author  Eric Monk
 * @version 1.0
 */

public class PositionModel extends Observable
{
    Point       pPosition = new Point();
    Rectangle   rectFieldSize;

    public PositionModel (Rectangle rectFieldSize, Point pInitPosition)
    {
        // check bounds
        pPosition.x = pInitPosition.x;
        pPosition.y = pInitPosition.y;
        this.rectFieldSize = rectFieldSize;
    }

    public Rectangle getFieldSize ()
    {
        return (rectFieldSize);
    }

    public Point getPosition ()
    {
        return (pPosition);
    }

    public void moveLeft (int iIncrement)
    {
        pPosition.x -= iIncrement;
        setChanged();
        notifyObservers(this);
    }

    public void moveRight (int iIncrement)
    {
        pPosition.x += iIncrement;
        setChanged();
        notifyObservers(this);
    }

    public void moveUp (int iIncrement)
    {
        pPosition.y -= iIncrement;
        setChanged();
        notifyObservers(this);
    }

    public void moveDown (int iIncrement)
    {
        pPosition.y += iIncrement;
        setChanged();
        notifyObservers(this);
    }

}